# Source based off https://git.soton.ac.uk/sts1u16/iclib/ -> common.cmake
# paths

set(CMAKE_TOOLCHAIN_FILE
    ${CMAKE_CURRENT_LIST_DIR}/msp430-toolchain.cmake)

# Force compiler detection so we can set up flags
enable_language(C)

include_directories($ENV{MSP_GCC_ROOT}/include) # MSP430 headers
add_compile_options(
    -std=c99
    -mmcu=msp430fr5994
    -msmall
    -mhwmult=none
    -fno-common
    -Wall
    )

# Linker scripts
set(CMAKE_EXE_LINKER_FLAGS
  "${CMAKE_EXE_LINKER_FLAGS} -T ${CMAKE_SOURCE_DIR}/../msp430fr5994.ld ")

# Add to search path for linker scripts (xx_symbols.ld, included by main linker script)
link_directories(
    $ENV{MSP_GCC_ROOT}/include
    $ENV{MSP_GCC_ROOT}/msp430-elf/lib/
    $ENV{MSP_GCC_ROOT}/lib/gcc/msp430-elf/7.3.2/
    )
